diff --git a/gcc/cp/parser.c b/gcc/cp/parser.c
index 46e2453..d09fa2c 100644
--- a/gcc/cp/parser.c
+++ b/gcc/cp/parser.c
@@ -782,7 +782,7 @@ cp_lexer_get_preprocessor_token (cp_lexer *lexer, cp_token *token)
 	}
       else
 	{
-          if (warn_cxx0x_compat
+          if (GCC_OPTION (warn_cxx0x_compat)
               && C_RID_CODE (token->u.value) >= RID_FIRST_CXX0X
               && C_RID_CODE (token->u.value) <= RID_LAST_CXX0X)
             {
@@ -4175,7 +4175,7 @@ cp_parser_primary_expression (cp_parser *parser,
 	 enumeration type.  */
       if (TREE_CODE (token->u.value) == REAL_CST
 	  && parser->integral_constant_expression_p
-	  && pedantic)
+	  && GCC_OPTION (pedantic))
 	{
 	  /* CAST_P will be set even in invalid code like "int(2.7 +
 	     ...)".   Therefore, we have to check that the next token
@@ -5812,7 +5812,7 @@ cp_parser_postfix_expression (cp_parser *parser, bool address_p, bool cast_p,
 	postfix_expression = 
 	  cp_parser_postfix_expression (parser, false, false, 
 					false, false, &idk);
-	if (!flag_cilkplus)
+	if (!GCC_OPTION (flag_cilkplus))
 	  {
 	    error_at (token->location, "-fcilkplus must be enabled to use"
 		      " %<_Cilk_spawn%>");
@@ -5837,7 +5837,7 @@ cp_parser_postfix_expression (cp_parser *parser, bool address_p, bool cast_p,
       }
       
     case RID_CILK_SYNC:
-      if (flag_cilkplus)
+      if (GCC_OPTION (flag_cilkplus))
 	{ 
 	  tree sync_expr = build_cilk_sync ();
 	  SET_EXPR_LOCATION (sync_expr, 
@@ -6378,7 +6378,7 @@ cp_parser_postfix_open_square_expression (cp_parser *parser,
 	  cp_lexer_set_source_position (parser->lexer);
 	  maybe_warn_cpp0x (CPP0X_INITIALIZER_LISTS);
 	  index = cp_parser_braced_list (parser, &expr_nonconst_p);
-	  if (flag_cilkplus
+	  if (GCC_OPTION (flag_cilkplus)
 	      && cp_lexer_peek_token (parser->lexer)->type == CPP_COLON)
 	    {
 	      error_at (cp_lexer_peek_token (parser->lexer)->location,
@@ -6388,7 +6388,7 @@ cp_parser_postfix_open_square_expression (cp_parser *parser,
 	      return error_mark_node;
 	    }
 	}
-      else if (flag_cilkplus)
+      else if (GCC_OPTION (flag_cilkplus))
 	{
 	  /* Here are have these two options:
 	     ARRAY[EXP : EXP]        - Array notation expr with default
@@ -6996,7 +6996,7 @@ cp_parser_unary_expression (cp_parser *parser, bool address_p, bool cast_p,
 	    /* Parse the cast-expression.  */
 	    expr = cp_parser_simple_cast_expression (parser);
 	    /* Restore the PEDANTIC flag.  */
-	    pedantic = saved_pedantic;
+	    GCC_OPTION (pedantic) = saved_pedantic;
 
 	    return expr;
 	  }
@@ -7766,7 +7766,7 @@ cp_parser_cast_expression (cp_parser *parser, bool address_p, bool cast_p,
 					    pidk);
 
 	  /* Warn about old-style casts, if so requested.  */
-	  if (warn_old_style_cast
+	  if (GCC_OPTION (warn_old_style_cast)
 	      && !in_system_header_at (input_location)
 	      && !VOID_TYPE_P (type)
 	      && current_lang_name != lang_name_c)
@@ -7902,7 +7902,7 @@ cp_parser_binary_expression (cp_parser* parser, bool cast_p,
       /* Get an operator token.  */
       token = cp_lexer_peek_token (parser->lexer);
 
-      if (warn_cxx0x_compat
+      if (GCC_OPTION (warn_cxx0x_compat)
           && token->type == CPP_RSHIFT
           && !parser->greater_than_is_operator_p)
         {
@@ -10921,7 +10921,7 @@ cp_parser_declaration (cp_parser* parser)
       /* Parse the qualified declaration.  */
       cp_parser_declaration (parser);
       /* Restore the PEDANTIC flag.  */
-      pedantic = saved_pedantic;
+      GCC_OPTION (pedantic) = saved_pedantic;
 
       return;
     }
@@ -11041,7 +11041,7 @@ cp_parser_block_declaration (cp_parser *parser,
       /* Parse the qualified declaration.  */
       cp_parser_block_declaration (parser, statement_p);
       /* Restore the PEDANTIC flag.  */
-      pedantic = saved_pedantic;
+      GCC_OPTION (pedantic) = saved_pedantic;
 
       return;
     }
@@ -13419,7 +13419,7 @@ cp_parser_template_id (cp_parser *parser,
 	  inform (next_token->location,
 		  "%<<:%> is an alternate spelling for %<[%>."
 		  " Insert whitespace between %<<%> and %<::%>");
-	  if (!hint && !flag_permissive)
+	  if (!hint && !GCC_OPTION (flag_permissive))
 	    {
 	      inform (next_token->location, "(if you use %<-fpermissive%> "
 		      "or %<-std=c++11%>, or %<-std=gnu++11%> G++ will "
@@ -17142,7 +17142,7 @@ cp_parser_direct_declarator (cp_parser* parser,
 		  /* In here, we handle cases where attribute is used after
 		     the function declaration.  For example:
 		     void func (int x) __attribute__((vector(..)));  */
-		  if (flag_cilkplus
+		  if (GCC_OPTION (flag_cilkplus)
 		      && cp_next_tokens_can_be_gnu_attribute_p (parser))
 		    {
 		      cp_parser_parse_tentatively (parser);
@@ -18628,7 +18628,7 @@ cp_parser_parameter_declaration (cp_parser *parser,
 
       if (!parser->default_arg_ok_p)
 	{
-	  if (flag_permissive)
+	  if (GCC_OPTION (flag_permissive))
 	    warning (0, "deprecated use of default argument for parameter of non-function");
 	  else
 	    {
@@ -19494,7 +19494,7 @@ cp_parser_class_specifier_1 (cp_parser* parser)
       if (pushed_scope)
 	pop_scope (pushed_scope);
       /* Now parse the body of the functions.  */
-      if (flag_openmp)
+      if (GCC_OPTION (flag_openmp))
 	{
 	  /* OpenMP UDRs need to be parsed before all other functions.  */
 	  FOR_EACH_VEC_SAFE_ELT (unparsed_funs_with_definitions, ix, decl)
@@ -20134,7 +20134,7 @@ cp_parser_member_declaration (cp_parser* parser)
       /* Recurse.  */
       cp_parser_member_declaration (parser);
       /* Restore the old value of the PEDANTIC flag.  */
-      pedantic = saved_pedantic;
+      GCC_OPTION (pedantic) = saved_pedantic;
 
       return;
     }
@@ -21640,7 +21640,7 @@ cp_parser_gnu_attributes_opt (cp_parser* parser)
 static inline bool
 is_cilkplus_vector_p (tree name)
 { 
-  if (flag_cilkplus && is_attribute_p ("vector", name)) 
+  if (GCC_OPTION (flag_cilkplus) && is_attribute_p ("vector", name)) 
     return true;
   return false;
 }
@@ -22048,7 +22048,7 @@ static bool
 cp_parser_extension_opt (cp_parser* parser, int* saved_pedantic)
 {
   /* Save the old value of the PEDANTIC flag.  */
-  *saved_pedantic = pedantic;
+  *saved_pedantic = GCC_OPTION (pedantic);
 
   if (cp_lexer_next_token_is_keyword (parser->lexer, RID_EXTENSION))
     {
@@ -22056,7 +22056,7 @@ cp_parser_extension_opt (cp_parser* parser, int* saved_pedantic)
       cp_lexer_consume_token (parser->lexer);
       /* We're not being pedantic while the `__extension__' keyword is
 	 in effect.  */
-      pedantic = 0;
+      GCC_OPTION (pedantic) = 0;
 
       return true;
     }
@@ -24612,7 +24612,7 @@ cp_parser_optional_template_keyword (cp_parser *parser)
 	 template and what is not.  In C++11,  per the resolution of DR 468,
 	 `template' is allowed in cases where it is not strictly necessary.  */
       if (!processing_template_decl
-	  && pedantic && cxx_dialect == cxx98)
+	  && GCC_OPTION (pedantic) && cxx_dialect == cxx98)
 	{
 	  cp_token *token = cp_lexer_peek_token (parser->lexer);
 	  pedwarn (token->location, OPT_Wpedantic,
@@ -27013,7 +27013,7 @@ cp_parser_omp_clause_name (cp_parser *parser)
 	    result = PRAGMA_OMP_CLAUSE_MAP;
 	  else if (!strcmp ("mergeable", p))
 	    result = PRAGMA_OMP_CLAUSE_MERGEABLE;
-	  else if (flag_cilkplus && !strcmp ("mask", p))
+	  else if (GCC_OPTION (flag_cilkplus) && !strcmp ("mask", p))
 	    result = PRAGMA_CILK_CLAUSE_MASK;
 	  break;
 	case 'n':
@@ -27021,7 +27021,7 @@ cp_parser_omp_clause_name (cp_parser *parser)
 	    result = PRAGMA_OMP_CLAUSE_NOTINBRANCH;
 	  else if (!strcmp ("nowait", p))
 	    result = PRAGMA_OMP_CLAUSE_NOWAIT;
-	  else if (flag_cilkplus && !strcmp ("nomask", p))
+	  else if (GCC_OPTION (flag_cilkplus) && !strcmp ("nomask", p))
 	    result = PRAGMA_CILK_CLAUSE_NOMASK;
 	  else if (!strcmp ("num_teams", p))
 	    result = PRAGMA_OMP_CLAUSE_NUM_TEAMS;
@@ -27069,7 +27069,7 @@ cp_parser_omp_clause_name (cp_parser *parser)
 	    result = PRAGMA_OMP_CLAUSE_UNTIED;
 	  break;
 	case 'v':
-	  if (flag_cilkplus && !strcmp ("vectorlength", p))
+	  if (GCC_OPTION (flag_cilkplus) && !strcmp ("vectorlength", p))
 	    result = PRAGMA_CILK_CLAUSE_VECTORLENGTH;
 	  break;
 	}
@@ -28398,7 +28398,7 @@ cp_parser_omp_all_clauses (cp_parser *parser, omp_clause_mask mask,
  saw_error:
   /* In Cilk Plus SIMD enabled functions there is no pragma_token, so
      no reason to skip to the end.  */
-  if (!(flag_cilkplus && pragma_tok == NULL))
+  if (!(GCC_OPTION (flag_cilkplus) && pragma_tok == NULL))
     cp_parser_skip_to_pragma_eol (parser, pragma_tok);
   if (finish_p)
     return finish_omp_clauses (clauses);
@@ -29594,7 +29594,7 @@ cp_parser_omp_for (cp_parser *parser, cp_token *pragma_tok,
 	    cclauses = cclauses_buf;
 
 	  cp_lexer_consume_token (parser->lexer);
-	  if (!flag_openmp)  /* flag_openmp_simd  */
+	  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	    return cp_parser_omp_simd (parser, pragma_tok, p_name, mask,
 				       cclauses);
 	  sb = begin_omp_structured_block ();
@@ -29614,7 +29614,7 @@ cp_parser_omp_for (cp_parser *parser, cp_token *pragma_tok,
 	  return ret;
 	}
     }
-  if (!flag_openmp)  /* flag_openmp_simd  */
+  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
     {
       cp_parser_require_pragma_eol (parser, pragma_tok);
       return NULL_TREE;
@@ -29806,7 +29806,7 @@ cp_parser_omp_parallel (cp_parser *parser, cp_token *pragma_tok,
 	cclauses = cclauses_buf;
 
       cp_lexer_consume_token (parser->lexer);
-      if (!flag_openmp)  /* flag_openmp_simd  */
+      if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	return cp_parser_omp_for (parser, pragma_tok, p_name, mask, cclauses);
       block = begin_omp_parallel ();
       save = cp_parser_begin_omp_structured_block (parser);
@@ -29823,7 +29823,7 @@ cp_parser_omp_parallel (cp_parser *parser, cp_token *pragma_tok,
       cp_parser_skip_to_pragma_eol (parser, pragma_tok);
       return NULL_TREE;
     }
-  else if (!flag_openmp)  /* flag_openmp_simd  */
+  else if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
     {
       cp_parser_require_pragma_eol (parser, pragma_tok);
       return NULL_TREE;
@@ -30056,7 +30056,7 @@ cp_parser_omp_distribute (cp_parser *parser, cp_token *pragma_tok,
 	  if (cclauses == NULL)
 	    cclauses = cclauses_buf;
 	  cp_lexer_consume_token (parser->lexer);
-	  if (!flag_openmp)  /* flag_openmp_simd  */
+	  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	    {
 	      if (simd)
 		return cp_parser_omp_simd (parser, pragma_tok, p_name, mask,
@@ -30086,7 +30086,7 @@ cp_parser_omp_distribute (cp_parser *parser, cp_token *pragma_tok,
 	  return ret;
 	}
     }
-  if (!flag_openmp)  /* flag_openmp_simd  */
+  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
     {
       cp_parser_require_pragma_eol (parser, pragma_tok);
       return NULL_TREE;
@@ -30146,7 +30146,7 @@ cp_parser_omp_teams (cp_parser *parser, cp_token *pragma_tok,
 	    cclauses = cclauses_buf;
 
 	  cp_lexer_consume_token (parser->lexer);
-	  if (!flag_openmp)  /* flag_openmp_simd  */
+	  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	    return cp_parser_omp_distribute (parser, pragma_tok, p_name, mask,
 					     cclauses);
 	  sb = begin_omp_structured_block ();
@@ -30165,7 +30165,7 @@ cp_parser_omp_teams (cp_parser *parser, cp_token *pragma_tok,
 	  return add_stmt (ret);
 	}
     }
-  if (!flag_openmp)  /* flag_openmp_simd  */
+  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
     {
       cp_parser_require_pragma_eol (parser, pragma_tok);
       return NULL_TREE;
@@ -30287,7 +30287,7 @@ cp_parser_omp_target (cp_parser *parser, cp_token *pragma_tok,
 
 	  cp_lexer_consume_token (parser->lexer);
 	  strcpy (p_name, "#pragma omp target");
-	  if (!flag_openmp)  /* flag_openmp_simd  */
+	  if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	    return cp_parser_omp_teams (parser, pragma_tok, p_name,
 					OMP_TARGET_CLAUSE_MASK, cclauses);
 	  keep_next_level (true);
@@ -30306,7 +30306,7 @@ cp_parser_omp_target (cp_parser *parser, cp_token *pragma_tok,
 	  add_stmt (stmt);
 	  return true;
 	}
-      else if (!flag_openmp)  /* flag_openmp_simd  */
+      else if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	{
 	  cp_parser_require_pragma_eol (parser, pragma_tok);
 	  return NULL_TREE;
@@ -30984,7 +30984,7 @@ cp_parser_omp_declare (cp_parser *parser, cp_token *pragma_tok,
 					   context);
 	  return;
 	}
-      if (!flag_openmp)  /* flag_openmp_simd  */
+      if (!GCC_OPTION (flag_openmp))  /* flag_openmp_simd  */
 	{
 	  cp_parser_require_pragma_eol (parser, pragma_tok);
 	  return;
@@ -31180,7 +31180,7 @@ cp_parser_transaction_expression (cp_parser *parser, enum rid keyword)
   gcc_assert (keyword == RID_TRANSACTION_ATOMIC
       || keyword == RID_TRANSACTION_RELAXED);
 
-  if (!flag_tm)
+  if (!GCC_OPTION (flag_tm))
     error (keyword == RID_TRANSACTION_RELAXED
 	   ? G_("%<__transaction_relaxed%> without transactional memory "
 		"support enabled")
@@ -31230,7 +31230,7 @@ cp_parser_transaction_expression (cp_parser *parser, enum rid keyword)
   if (cp_parser_non_integral_constant_expression (parser, NIC_TRANSACTION))
     return error_mark_node;
 
-  return (flag_tm ? expr : error_mark_node);
+  return (GCC_OPTION (flag_tm) ? expr : error_mark_node);
 }
 
 /* Parse a function-transaction-block.
@@ -31312,7 +31312,7 @@ cp_parser_transaction_cancel (cp_parser *parser)
 
   cp_parser_require (parser, CPP_SEMICOLON, RT_SEMICOLON);
 
-  if (!flag_tm)
+  if (!GCC_OPTION (flag_tm))
     {
       error_at (token->location, "%<__transaction_cancel%> without "
 		"transactional memory support enabled");
@@ -31640,7 +31640,7 @@ c_parse_file (void)
   already_called = true;
 
   the_parser = cp_parser_new ();
-  push_deferring_access_checks (flag_access_control
+  push_deferring_access_checks (GCC_OPTION (flag_access_control)
 				? dk_no_deferred : dk_no_check);
   cp_parser_translation_unit (the_parser);
   the_parser = NULL;
diff --git a/gcc/cp/pt.c b/gcc/cp/pt.c
index c791d03..0148865 100644
--- a/gcc/cp/pt.c
+++ b/gcc/cp/pt.c
@@ -6399,7 +6399,7 @@ convert_template_argument (tree parm,
 	  else if (complain & tf_warning_or_error)
 	    pedwarn (input_location, OPT_Wpedantic, "injected-class-name %qD"
 		     " used as template template argument", TYPE_NAME (arg));
-	  else if (flag_pedantic_errors)
+	  else if (GCC_OPTION (flag_pedantic_errors))
 	    t = arg;
 
 	  arg = t;
@@ -8754,7 +8754,7 @@ apply_late_template_attributes (tree *decl_p, tree attributes, int attr_flags,
 	    {
 	      *p = TREE_CHAIN (t);
 	      TREE_CHAIN (t) = NULL_TREE;
-	      if ((flag_openmp || flag_cilkplus)
+	      if ((GCC_OPTION (flag_openmp) || GCC_OPTION (flag_cilkplus))
 		  && is_attribute_p ("omp declare simd",
 				     get_attribute_name (t))
 		  && TREE_VALUE (t))
@@ -11959,7 +11959,7 @@ tsubst (tree t, tree args, tsubst_flags_t complain, tree in_decl)
 	if (cxx_dialect >= cxx1y
 	    && !(TREE_CODE (t) == REFERENCE_TYPE && REFERENCE_VLA_OK (t))
 	    && array_of_runtime_bound_p (type)
-	    && (flag_iso || warn_vla > 0))
+	    && (flag_iso || GCC_OPTION (warn_vla) > 0))
 	  {
 	    if (complain & tf_warning_or_error)
 	      pedwarn
@@ -14252,7 +14252,7 @@ tsubst_copy_and_build (tree t,
 
 	op = RECUR (TREE_OPERAND (t, 0));
 
-	warning_sentinel s(warn_useless_cast);
+	warning_sentinel s(GCC_OPTION (warn_useless_cast));
 	switch (TREE_CODE (t))
 	  {
 	  case CAST_EXPR:
@@ -14347,8 +14347,8 @@ tsubst_copy_and_build (tree t,
     case MEMBER_REF:
     case DOTSTAR_EXPR:
       {
-	warning_sentinel s1(warn_type_limits);
-	warning_sentinel s2(warn_div_by_zero);
+	warning_sentinel s1(GCC_OPTION (warn_type_limits));
+	warning_sentinel s2(GCC_OPTION (warn_div_by_zero));
 	tree r = build_x_binary_op
 	  (input_location, TREE_CODE (t),
 	   RECUR (TREE_OPERAND (t, 0)),
@@ -14478,7 +14478,7 @@ tsubst_copy_and_build (tree t,
 
     case MODOP_EXPR:
       {
-	warning_sentinel s(warn_div_by_zero);
+	warning_sentinel s(GCC_OPTION (warn_div_by_zero));
 	tree r = build_x_modify_expr
 	  (EXPR_LOCATION (t),
 	   RECUR (TREE_OPERAND (t, 0)),
@@ -17394,7 +17394,7 @@ unify (tree tparms, tree targs, tree parm, tree arg, int strict,
 
       /* Replace T with std::initializer_list<T> for deduction.  */
       if (TREE_CODE (parm) == TEMPLATE_TYPE_PARM
-	  && flag_deduce_init_list)
+	  && GCC_OPTION (flag_deduce_init_list))
 	parm = listify (parm);
 
       if (!is_std_init_list (parm)
@@ -18156,7 +18156,7 @@ mark_decl_instantiated (tree result, int extern_p)
       mark_definable (result);
       mark_needed (result);
       /* Always make artificials weak.  */
-      if (DECL_ARTIFICIAL (result) && flag_weak)
+      if (DECL_ARTIFICIAL (result) && GCC_OPTION (flag_weak))
 	comdat_linkage (result);
       /* For WIN32 we also want to put explicit instantiations in
 	 linkonce sections.  */
diff --git a/gcc/cp/repo.c b/gcc/cp/repo.c
index f076f23..e7954d1 100644
--- a/gcc/cp/repo.c
+++ b/gcc/cp/repo.c
@@ -99,11 +99,11 @@ get_base_filename (const char *filename)
 
       if (strcmp (q, "-o") == 0)
 	{
-	  if (flag_compare_debug)
+	  if (GCC_OPTION (flag_compare_debug))
 	    /* Just in case aux_base_name was based on a name with two
 	       or more '.'s, add an arbitrary extension that will be
 	       stripped by the caller.  */
-	    output = concat (aux_base_name, ".o", NULL);
+	    output = concat (GCC_OPTION (aux_base_name), ".o", NULL);
 	  else
 	    output = extract_string (&p);
 	}
@@ -175,7 +175,7 @@ init_repo (void)
   if (!temporary_obstack_initialized_p)
     gcc_obstack_init (&temporary_obstack);
 
-  repo_file = open_repo_file (main_input_filename);
+  repo_file = open_repo_file (GCC_OPTION (main_input_filename));
 
   if (repo_file == 0)
     return;
@@ -241,7 +241,7 @@ finish_repo (void)
   FILE *repo_file;
   unsigned ix;
 
-  if (!flag_use_repository || flag_compare_debug)
+  if (!flag_use_repository || GCC_OPTION (flag_compare_debug))
     return;
 
   if (seen_error ())
@@ -251,7 +251,7 @@ finish_repo (void)
   if (repo_file == 0)
     goto out;
 
-  fprintf (repo_file, "M %s\n", main_input_filename);
+  fprintf (repo_file, "M %s\n", GCC_OPTION (main_input_filename));
   dir = getpwd ();
   fprintf (repo_file, "D %s\n", dir);
   args = getenv ("COLLECT_GCC_OPTIONS");
diff --git a/gcc/cp/rtti.c b/gcc/cp/rtti.c
index a8e6d25..af39791 100644
--- a/gcc/cp/rtti.c
+++ b/gcc/cp/rtti.c
@@ -285,7 +285,7 @@ typeid_ok_p (void)
 {
   tree pseudo_type_info, type_info_type;
 
-  if (! flag_rtti)
+  if (! GCC_OPTION (flag_rtti))
     {
       error ("cannot use typeid with -fno-rtti");
       return false;
@@ -690,7 +690,7 @@ build_dynamic_cast_1 (tree type, tree expr, tsubst_flags_t complain)
 	    }
 
 	  /* Use of dynamic_cast when -fno-rtti is prohibited.  */
-	  if (!flag_rtti)
+	  if (!GCC_OPTION (flag_rtti))
 	    {
               if (complain & tf_error)
                 error ("%<dynamic_cast%> not permitted with -fno-rtti");
@@ -1536,7 +1536,7 @@ emit_support_tinfos (void)
 
 	     It might also not be necessary to follow this detail of the
 	     ABI.  */
-	  if (!flag_weak || ! targetm.cxx.library_rtti_comdat ())
+	  if (!GCC_OPTION (flag_weak) || ! targetm.cxx.library_rtti_comdat ())
 	    {
 	      gcc_assert (TREE_PUBLIC (tinfo) && !DECL_COMDAT (tinfo));
 	      DECL_INTERFACE_KNOWN (tinfo) = 1;
diff --git a/gcc/cp/search.c b/gcc/cp/search.c
index d99e182..afe7de5 100644
--- a/gcc/cp/search.c
+++ b/gcc/cp/search.c
@@ -2143,14 +2143,14 @@ get_pure_virtuals (tree type)
 void
 maybe_suppress_debug_info (tree t)
 {
-  if (write_symbols == NO_DEBUG)
+  if (GCC_OPTION (write_symbols) == NO_DEBUG)
     return;
 
   /* We might have set this earlier in cp_finish_decl.  */
   TYPE_DECL_SUPPRESS_DEBUG (TYPE_MAIN_DECL (t)) = 0;
 
   /* Always emit the information for each class every time. */
-  if (flag_emit_class_debug_always)
+  if (GCC_OPTION (flag_emit_class_debug_always))
     return;
 
   /* If we already know how we're handling this class, handle debug info
diff --git a/gcc/cp/semantics.c b/gcc/cp/semantics.c
index 886fbb8..3f43563 100644
--- a/gcc/cp/semantics.c
+++ b/gcc/cp/semantics.c
@@ -650,7 +650,7 @@ maybe_convert_cond (tree cond)
   if (processing_template_decl)
     return cond;
 
-  if (warn_sequence_point)
+  if (GCC_OPTION (warn_sequence_point))
     verify_sequence_points (cond);
 
   /* Do the conversion.  */
@@ -658,7 +658,7 @@ maybe_convert_cond (tree cond)
 
   if (TREE_CODE (cond) == MODIFY_EXPR
       && !TREE_NO_WARNING (cond)
-      && warn_parentheses)
+      && GCC_OPTION (warn_parentheses))
     {
       warning (OPT_Wparentheses,
 	       "suggest parentheses around assignment used as truth value");
@@ -679,7 +679,7 @@ finish_expr_stmt (tree expr)
     {
       if (!processing_template_decl)
 	{
-	  if (warn_sequence_point)
+	  if (GCC_OPTION (warn_sequence_point))
 	    verify_sequence_points (expr);
 	  expr = convert_to_void (expr, ICV_STATEMENT, tf_warning_or_error);
 	}
@@ -863,11 +863,11 @@ finish_return_stmt (tree expr)
   expr = check_return_expr (expr, &no_warning);
 
   if (error_operand_p (expr)
-      || (flag_openmp && !check_omp_return ()))
+      || (GCC_OPTION (flag_openmp) && !check_omp_return ()))
     return error_mark_node;
   if (!processing_template_decl)
     {
-      if (warn_sequence_point)
+      if (GCC_OPTION (warn_sequence_point))
 	verify_sequence_points (expr);
       
       if (DECL_DESTRUCTOR_P (current_function_decl)
@@ -898,7 +898,7 @@ tree
 begin_for_scope (tree *init)
 {
   tree scope = NULL_TREE;
-  if (flag_new_for_scope > 0)
+  if (GCC_OPTION (flag_new_for_scope) > 0)
     scope = do_pushlevel (sk_for);
 
   if (processing_template_decl)
@@ -923,7 +923,7 @@ begin_for_stmt (tree scope, tree init)
 
   if (scope == NULL_TREE)
     {
-      gcc_assert (!init || !(flag_new_for_scope > 0));
+      gcc_assert (!init || !(GCC_OPTION (flag_new_for_scope) > 0));
       if (!init)
 	scope = begin_for_scope (&init);
     }
@@ -981,7 +981,7 @@ finish_for_expr (tree expr, tree for_stmt)
     }
   if (!processing_template_decl)
     {
-      if (warn_sequence_point)
+      if (GCC_OPTION (warn_sequence_point))
 	verify_sequence_points (expr);
       expr = convert_to_void (expr, ICV_THIRD_IN_FOR,
                               tf_warning_or_error);
@@ -1011,7 +1011,7 @@ finish_for_stmt (tree for_stmt)
     FOR_BODY (for_stmt) = do_poplevel (FOR_BODY (for_stmt));
 
   /* Pop the scope for the body of the loop.  */
-  if (flag_new_for_scope > 0)
+  if (GCC_OPTION (flag_new_for_scope) > 0)
     {
       tree scope;
       tree *scope_ptr = (TREE_CODE (for_stmt) == RANGE_FOR_STMT
@@ -1040,7 +1040,7 @@ begin_range_for_stmt (tree scope, tree init)
 
   if (scope == NULL_TREE)
     {
-      gcc_assert (!init || !(flag_new_for_scope > 0));
+      gcc_assert (!init || !(GCC_OPTION (flag_new_for_scope) > 0));
       if (!init)
 	scope = begin_for_scope (&init);
     }
@@ -1135,7 +1135,7 @@ finish_switch_cond (tree cond, tree switch_stmt)
     }
   if (check_for_bare_parameter_packs (cond))
     cond = error_mark_node;
-  else if (!processing_template_decl && warn_sequence_point)
+  else if (!processing_template_decl && GCC_OPTION (warn_sequence_point))
     verify_sequence_points (cond);
 
   finish_cond (&SWITCH_STMT_COND (switch_stmt), cond);
@@ -2322,7 +2322,7 @@ finish_call_expr (tree fn, vec<tree, va_gc> **args, bool disallow_virtual,
 
       if (!result)
 	{
-	  if (warn_sizeof_pointer_memaccess
+	  if (GCC_OPTION (warn_sizeof_pointer_memaccess)
 	      && !vec_safe_is_empty (*args)
 	      && !processing_template_decl)
 	    {
@@ -2778,7 +2778,7 @@ begin_class_definition (tree t)
   pushclass (t);
   TYPE_BEING_DEFINED (t) = 1;
 
-  if (flag_pack_struct)
+  if (GCC_OPTION (flag_pack_struct))
     {
       tree v;
       TYPE_PACKED (t) = 1;
@@ -3991,10 +3991,10 @@ expand_or_defer_fn_1 (tree fn)
 	 this function as needed so that finish_file will make sure to
 	 output it later.  Similarly, all dllexport'd functions must
 	 be emitted; there may be callers in other DLLs.  */
-      if ((flag_keep_inline_functions
+      if ((GCC_OPTION (flag_keep_inline_functions)
 	   && DECL_DECLARED_INLINE_P (fn)
 	   && !DECL_REALLY_EXTERN (fn))
-	  || (flag_keep_inline_dllexport
+	  || (GCC_OPTION (flag_keep_inline_dllexport)
 	      && lookup_attribute ("dllexport", DECL_ATTRIBUTES (fn))))
 	{
 	  mark_needed (fn);
@@ -4018,7 +4018,7 @@ expand_or_defer_fn_1 (tree fn)
 
   /* There's no reason to do any of the work here if we're only doing
      semantic analysis; this code just generates RTL.  */
-  if (flag_syntax_only)
+  if (GCC_OPTION (flag_syntax_only))
     return false;
 
   return true;
@@ -6729,7 +6729,7 @@ begin_transaction_stmt (location_t loc, tree *pcompound, int flags)
   r = build_stmt (loc, TRANSACTION_EXPR, NULL_TREE);
 
   /* Only add the statement to the function if support enabled.  */
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     add_stmt (r);
   else
     error_at (loc, ((flags & TM_STMT_ATTR_RELAXED) != 0
@@ -7040,7 +7040,7 @@ finish_decltype_type (tree expr, bool id_expression_or_member_access_p,
     }
 
   if (cxx_dialect >= cxx1y && array_of_runtime_bound_p (type)
-      && (flag_iso || warn_vla > 0))
+      && (flag_iso || GCC_OPTION (warn_vla) > 0))
     {
       if (complain & tf_warning_or_error)
 	pedwarn (input_location, OPT_Wvla,
@@ -8318,7 +8318,7 @@ push_cx_call_context (tree call)
   if (!EXPR_HAS_LOCATION (call))
     SET_EXPR_LOCATION (call, input_location);
   call_stack.safe_push (call);
-  if (call_stack.length () > (unsigned) max_constexpr_depth)
+  if (call_stack.length () > (unsigned) GCC_OPTION (max_constexpr_depth))
     return false;
   return true;
 }
@@ -8465,7 +8465,7 @@ cxx_eval_call_expression (const constexpr_call *old_call, tree t,
       if (!allow_non_constant)
 	error ("constexpr evaluation depth exceeds maximum of %d (use "
 	       "-fconstexpr-depth= to increase the maximum)",
-	       max_constexpr_depth);
+	       GCC_OPTION (max_constexpr_depth));
       *non_constant_p = true;
       entry->result = result = error_mark_node;
     }
@@ -8540,7 +8540,7 @@ verify_constant (tree t, bool allow_non_constant, bool *non_constant_p,
 	  permerror (input_location, "overflow in constant expression");
 	  /* If we're being permissive (and are in an enforcing
 	     context), ignore the overflow.  */
-	  if (flag_permissive)
+	  if (GCC_OPTION (flag_permissive))
 	    return *non_constant_p;
 	}
       *overflow_p = true;
@@ -9427,7 +9427,7 @@ cxx_eval_constant_expression (const constexpr_call *call, tree t,
     {
       if (TREE_CODE (t) == PTRMEM_CST)
 	t = cplus_expand_constant (t);
-      else if (TREE_OVERFLOW (t) && (!flag_permissive || allow_non_constant))
+      else if (TREE_OVERFLOW (t) && (!GCC_OPTION (flag_permissive) || allow_non_constant))
 	*overflow_p = true;
       return t;
     }
